﻿--[[Written by: David - Zalra @ Hyjal (Alliance)
Contact:
	In Game: Zalra @ Hyjal (Alliance)
	Email: Davieboy53@yahoo.com
	XFire: Dawnseclipse	
	Curse/Wowace/WowInterface Username: Davie3
]]

WhoPinged = LibStub("AceAddon-3.0"):NewAddon("WhoPinged", "AceEvent-3.0", "AceConsole-3.0")
local AceConfig = LibStub("AceConfigDialog-3.0");

local PlayerWhoPinged;
local PingedMessage;
local ClassColor;
local hour,minute;
local BgDisable = false;

function WhoPinged:OnInitialize()
	WhoPinged:RegisterEvent("MINIMAP_PING", "MapPing")
	WhoPinged:RegisterEvent("PLAYER_ENTERING_WORLD", "EnteringWorldOnEvent")
	WhoPinged:RegisterEvent("ADDON_LOADED", "AddonLoaded")
	
	WhoPinged:RegisterChatCommand("whopinged", "ChatCommand")
	WhoPinged:RegisterChatCommand("wp", "ChatCommand")
	
	WhoPinged.db = LibStub("AceDB-3.0"):New("WhoPingedDB", WhoPinged.defaults, "profile");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("WhoPinged", WhoPinged.options)
	AceConfig:AddToBlizOptions("WhoPinged", "WhoPinged");
end

function WhoPinged:AddonLoaded()
	if (arg1 == "WhoPinged") then
		if (WhoPinged.db.profile.Disabled == false) then
			WhoPinged:Print("Enabled");
		else
			WhoPinged:Print("Disabled");
		end
	end
end

function WhoPinged:ChatCommand()
	LibStub("AceConfigDialog-3.0"):Open("WhoPinged");
end

function WhoPinged:MapPing()
	if (WhoPinged.db.profile.Disabled == false) and (BgDisable == false) then
		WhoPinged:Ping(arg1)
	end
end

function WhoPinged:EnteringWorldOnEvent()
	local inInstance, instanceType = IsInInstance()
	if (inInstance == 1) and (instanceType == "pvp") then
		BgDisable = true;
	else
		BgDisable = false;
	end
end

function WhoPinged:Ping(UnitId)
	PlayerWhoPinged = UnitName(UnitId);
	if (WhoPinged.db.profile.ServerTime == false) then
		hour, minute = tonumber(date("%H")), tonumber(date("%M"));
	else
		hour,minute = GetGameTime();
	end
	if (hour >= 13) then
		hour = hour - 12;
	end
	
	WhoPinged:GetClassColor(UnitId);
	
	PingedMessage = "|c"..ClassColor.."".. PlayerWhoPinged .."|r |c00CCCCCCpinged the minimap at ";
	if (minute < 10) then
		PingedMessage = PingedMessage.. hour .. ":0" .. minute;
	else
		PingedMessage = PingedMessage.. hour .. ":" .. minute;
	end
	if (WhoPinged.db.profile.ServerTime == true) then
		PingedMessage = PingedMessage.. " server time.|r"
	else
		PingedMessage = PingedMessage.. " local time.|r"
	end	
	WhoPinged:Print(PingedMessage);

	--if (minute < 10) then
		--WhoPinged:Print("|c"..ClassColor.."".. PlayerWhoPinged .."|r |c00CCCCCCpinged the minimap at " .. hour .. ":0" .. minute .. " server time.|r");
	--else
		--WhoPinged:Print("|c"..ClassColor.."".. PlayerWhoPinged .."|r |c00CCCCCCpinged the minimap at " .. hour .. ":" .. minute .. " server time.|r");
	--end
end

function WhoPinged:GetClassColor(UnitId)
	local localizedclass = UnitClass(UnitId);	
	--English
	if (localizedclass == "Death Knight") then
		ClassColor = "00C41F3B";	
	elseif (localizedclass == "Druid") then
		ClassColor = "00FF7D0A";
	elseif (localizedclass == "Hunter") then
		ClassColor = "00ABD473";
	elseif (localizedclass == "Mage") then
		ClassColor = "0069CCF0";
	elseif (localizedclass == "Paladin") then
		ClassColor = "00F58CBA";
	elseif (localizedclass == "Priest") then
		ClassColor = "00FFFFFF";
	elseif (localizedclass == "Rogue") then
		ClassColor = "00FFF569";
	elseif (localizedclass == "Shaman") then
		ClassColor = "002459FF";
	elseif (localizedclass == "Warlock") then
		ClassColor = "009482CA";
	elseif (localizedclass == "Warrior") then
		ClassColor = "00C79C6E";	
	--German (Thanks Maischter from Curse!)	
	elseif (localizedclass == "Todesritter") then
		ClassColor = "00C41F3B";
	elseif (localizedclass == "Krieger") then
		ClassColor = "00C79C6E";
	elseif (localizedclass == "Kriegerin") then
		ClassColor = "00C79C6E";
	elseif (localizedclass == "Druide") then
		ClassColor = "00FF7D0A";
	elseif (localizedclass == "Druidin") then
		ClassColor = "00FF7D0A";
	elseif (localizedclass == "Jäger") then
		ClassColor = "00ABD473";
	elseif (localizedclass == "Jägerin") then
		ClassColor = "00ABD473";
	elseif (localizedclass == "Magier") then
		ClassColor = "0069CCF0";
	elseif (localizedclass == "Magierin") then
		ClassColor = "0069CCF0";
	elseif (localizedclass == "Priester") then
		ClassColor = "00FFFFFF";
	elseif (localizedclass == "Priesterin") then
		ClassColor = "00FFFFFF";
	elseif (localizedclass == "Schurke") then
		ClassColor = "00FFF569";
	elseif (localizedclass == "Schurkin") then
		ClassColor = "00FFF569";
	elseif (localizedclass == "Hexenmeister") then
		ClassColor = "009482CA";
	elseif (localizedclass == "Hexenmeisterin") then
		ClassColor = "009482CA";
	elseif (localizedclass == "Schamane") then
		ClassColor = "002459FF";
	elseif (localizedclass == "Schamanin") then
		ClassColor = "002459FF";
	end
end

